function createTag (tagname, id, content)
{
	var tag = "<"+tagname;
	if (id!="") tag+=(" id="+id);
	tag += ">";
	if (content!="") tag+=content;
	tag += "</"+tagname+">";
	return tag;
}

function getDevType()
{
	switch(gDT) {
		default:
		case 0: return "unsupported";
		case 1: return "master";
		case 2: return "endpoint";
	}
}
function getKeyLayout()
{
	switch (gKL) {
		default:
		case KL_NONE: return "----";
		case KL_A60:  return "ANNUNCICOM 60";
		case KL_A100: return "PS1";
		case KL_PS16: return "PS16";
	}
}

function drawKey(id,hdr1,hdr2,row1,row2,row3,last)
{
	var sz;
		
	sz="<li class='k'><span class=k>";
	sz+="<span class='k ka'>"+hdr1+"</span>";
	if(hdr2!="")sz+=" / <span class='k kb'>"+hdr2+"</span>";
	sz+="</span><br>";
	if(row3=="")sz+="<br>";
	if(row2=="")sz+="<br>";
	sz+=row1+"<br>";
	if(row2!="")sz+=row2+"<br>";
	if(row3!="")sz+=row3;
	sz+="</li>";

	return sz;
}
function drawLayout(type)
{
	var kl="<ul class=k>";
	switch(gKL) {
		case KL_NONE:
		document.getElementById('kltitle').style.display="none";
		break;
		case KL_A60:
		document.getElementById('kcont').style.width="67px";
		kl+=drawKey(0,'I0','','Page','Group 1','',0);
		break;
		case KL_A100:
		document.getElementById('kcont').style.width="134px";
		kl+=drawKey(0,'A','','Page','Group 1','',0);
		kl+=drawKey(1,'B','','Page','Group 2','',1);
		break;
		case KL_PS16:
		if (gNXT != 0){
			document.getElementById('kcont').style.width="469px";
			kl+=drawKey(8,'1','','Select','Group 1','',0);
			kl+=drawKey(9,'2','','Select','Group 2','',0);
			kl+=drawKey(10,'3','','Select','Group 3','',0);
			kl+=drawKey(11,'4','','Select','Group 4','',0);
			kl+=drawKey(12,'5','','Select','Group 5','',0);
			kl+=drawKey(13,'6','','Select','Group 6','',0);
			kl+=drawKey(14,'7','','Select','Group 7','',1);
			kl+=drawKey(15,'8','','Select','Group 8','',0);
			kl+=drawKey(0,'9', '','Select','Group 9','',0);
			kl+=drawKey(1,'10','','Select','Group 10','',0);
			kl+=drawKey(2,'11','','Select','Group 11','',0);
			kl+=drawKey(3,'12','','Select','Group 12','',0);
			kl+=drawKey(4,'13','','Select','Group 13','',0);
			kl+=drawKey(5,'14','','Select','Group 14','',1);
			kl+=drawKey(7,'16','','Page','','',0);
			kl+=drawKey(6,'15','','Select','All','',1);
			
		}else{
			document.getElementById('kcont').style.width="536px";
			kl+=drawKey(8,'1','','Select','Group 1','',0);
			kl+=drawKey(9,'2','','Select','Group 2','',0);
			kl+=drawKey(10,'3','','Select','Group 3','',0);
			kl+=drawKey(11,'4','','Select','Group 4','',0);
			kl+=drawKey(12,'5','','Select','Group 5','',0);
			kl+=drawKey(13,'6','','Select','Group 6','',0);
			kl+=drawKey(14,'7','','Select','Group 7','',0);
			kl+=drawKey(15,'8','','Select','Group 8','',1);
			kl+=drawKey(0,'9', '','Select','Group 9','',0);
			kl+=drawKey(1,'10','','Select','Group 10','',0);
			kl+=drawKey(2,'11','','Select','Group 11','',0);
			kl+=drawKey(3,'12','','Select','Group 12','',0);
			kl+=drawKey(4,'13','','Select','Group 13','',0);
			kl+=drawKey(5,'14','','Select','Group 14','',0);
			kl+=drawKey(6,'15','','Select','All','',0);
			kl+=drawKey(7,'16','','Page','','',1);
		}
		break;
	}
	kl+="</ul>";
	document.getElementById('kmap').innerHTML=kl;
}

function translateState(val)
{
	switch (val) {
	case '0': return "&nbsp;&nbsp;IDLE&nbsp;&nbsp;";
	case '1': return "&nbsp;&nbsp;SENDING STREAM&nbsp;&nbsp;";
	case '2': return "&nbsp;&nbsp;PLAYING STREAM&nbsp;&nbsp;";
	case '3': return "&nbsp;&nbsp;PLAYING BGM STREAM&nbsp;&nbsp;";
	case '4': return "&nbsp;&nbsp;PLAYING NOTIFICATION&nbsp;&nbsp;";
	case '5': return "&nbsp;&nbsp;WAITING FOR BGM STREAM&nbsp;&nbsp;";
	
	}
}
function init()
{
	var klout,devtype;
	/* default, hide x8 keymap container */
	devtype=getDevType();
	/* keyboard layout */
	drawLayout();
}
function ShowHideBasicSections()
{
	detectHW();
	
	document.getElementById('grpPS1').style.display="none";
	document.getElementById('grpPS16').style.display="none";
	document.getElementById('grpcom').style.display="none";
	
	// dec only, hide encoding
	if (gDT!=2) {
		document.getElementById('grpcom').style.display="";
		if (gHT==APS1||gHT==APS16||gUIMODE==uimode_gateway) {
			document.getElementById('grpPS1').style.display="";
		}
		if (gHT==APS16||gUIMODE==uimode_gateway) {
			document.getElementById('grpPS16').style.display="";
		}
		// if we use Nextion Panel, show all groups
		if (gNXT > 0) {
			document.getElementById('grpPS1').style.display="";
			document.getElementById('grpPS16').style.display="";
		}
	}
}
function ShowHideAdvancedSections()
{
	// first, enable encoder/decoder sections
	var q;
	var enc = document.getElementsByName("encoder");
	
	detectHW();
	
	// dec only, hide encoding
	if (gDT==2) {
		for (q=0;q<enc.length;++q) enc[q].style.display="none";
	}
	// otherwise always enc+dec
	else {
	}
}
function SetUIMode() {
	var mo = document.getElementsByName('mo'); // master only
	var mg = document.getElementsByName('mg'); // master & gw
	var me = document.getElementsByName('me'); // master & ep
	var eo = document.getElementsByName('eo'); // ep only
	var i;

	for (i=0;i<mo.length;++i) mo[i].style.display="none";
	for (i=0;i<mg.length;++i) mg[i].style.display="none";
	for (i=0;i<me.length;++i) me[i].style.display="none";
	for (i=0;i<eo.length;++i) eo[i].style.display="none";
 
	if (gUIMODE==uimode_master) {
		for (i=0;i<mo.length;++i) mo[i].style.display="";
		for (i=0;i<mg.length;++i) mg[i].style.display="";
		for (i=0;i<me.length;++i) me[i].style.display="";
	}
	else if (gUIMODE==uimode_gateway) {
		for (i=0;i<mg.length;++i) mg[i].style.display="";
	}
	else if (gUIMODE==uimode_endpoint) {
		for (i=0;i<me.length;++i) me[i].style.display="";
		for (i=0;i<eo.length;++i) eo[i].style.display="";
	}
}	
